/*
 *	main.c
 *
 *	ȃ|ǂ
 *
 *	* Thu Jan 31 20:00:00 JST 2003 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

#define USE_MUSIC /* yCugꍇ́ÃV{`Ă */
#ifdef USE_MUSIC
#include "instdef2.c"
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

#define V_SCREEN /* cʃ[hgꍇ́ÃV{`Ă */
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* 얂~ĵĂ */
static const unsigned char BGM1[] =
#include "mus/bgm1.c"
static const unsigned char SND1[] =
#include "snd/snd1.c"
static const unsigned char SND2[] =
#include "snd/snd2.c"
static const unsigned char SND3[] =
#include "snd/snd3.c"
static const unsigned char SND4[] =
#include "snd/snd4.c"
static const unsigned char SND5[] =
#include "snd/snd5.c"
/* ^NoĝĂ */
extern const unsigned char SND6[];
extern const unsigned char SND7[];
extern const unsigned char SND8[];

#define CH_USR	1	/* [U[ɋNʉ */
#define CH_ENV	2	/* [U[ɋNȂAʏʉ */
#define CH_SYS	3	/* [U[ɋNȂAʉ */

#define SND_HIT		SND1	/* qbg */
#define SND_SHOT	SND2	/* Vbg */
#define SND_EXPLOSION	SND3	/*  */
#define SND_FALL	SND4	/* n */
#define SND_CLEAR_GEN	SND5	/* NA^[Qbgo */
#define SND_WARNING	SND6	/* 댯][x */
#define SND_DOWN	SND7	/* tB[h~ */
#define SND_GAMEOVER	SND8	/* Q[I[o[ */

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.33)

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

/* CELL.type */
#define CELL_TYPE_BLANK		0	/*  */
#define CELL_TYPE_TARGET	1	/* ^[Qbg */
#define CELL_TYPE_PARTS		2	/* p[c */
#define CELL_TYPE_EXPLOSION	3	/*  */
/* CELL.color */
					/* 0`3:ʏ^[Qbg */
#define CELL_COLOR_CLEAR	4	/* NA^[Qbg */
#define NUM_COLORS		5	/* NA^[Qbg܂߂čő5F */
/* CELL.stat */
#define CELL_STAT_NORMAL	0	/* ʏ */
#define CELL_STAT_ERASE		1	/* ^[QbgEp[ĉ݁Aorő҂ */

typedef struct _CELL {
	unsigned char type;
	unsigned char color;		/* type<>0̂ݗL */
	unsigned char group;		/* type<>0̂ݗLA0:/1`:O[vԍ */
	unsigned char stat;
	short cnt;			/* CELL_STAT_ERASẼJEg_E^C}ƂĎgp */
} CELL;

/* PLAYER.stat */
#define PLAYER_STAT_NORMAL	0	/* ʏ */
#define PLAYER_STAT_SHOT	1	/* Vbg̔ */

typedef struct _PLAYER {
	unsigned char stat;
	unsigned char reserved;
	short col;
	short cnt;
} PLAYER;

/* SHOT.color */
#define SHOT_COLOR_INVALID	5	/* Vbg */

typedef struct _SHOT {
	unsigned char stat;		/* 0:Ȃ/1: */
	unsigned char color;		/* 0`3:ʏ/4:NA/SHOT_COLOR_INVALID:Vbg */
	short col;
	short row;
} SHOT;

/* EŉsɃ^[QbgBƃQ[I[o[łB */
/* E{͍ŉsɃp[cu܂񂪁A͒u悤ɂĂ݂܂B */
/* @ŉs̈܂Ń^[QbgŖ܂ꍇ̋~ύłB */
#define FIELD_COLS		 9	/* tB[h */
#define FIELD_ROWS		11	/* tB[hs */

typedef struct _GI {
	/* Q[f[^ */
	int score;		/* XRA */
	short stage;		/* Xe[Wԍ(\+1) */
	short round;		/* Ehԍ(\+1) */
	int anm;		/* Aj[VJE^ */
	int seed;		/* V[h */
	/* Ehf[^ */
	struct _LEVEL* level;	/* ݂̃xf[^ւ̃|C^ */
	int down_time;		/* tB[h~p^C}(0x10000𒴂~) */
	int erase_cnt;		/* ^[QbgJE^iNA^[Qbgopj */
	int clear_gen;		/* EhJn0ANA^[Qbg𐶐1 */
	int combo;		/* AJEgiŏ̏ł1Ƃj */
	PLAYER player;		/* vC[ */
	SHOT shot;		/* Vbg */
	CELL field[FIELD_ROWS][FIELD_COLS];	/* tB[h */
} GI;

///#define LEVEL_COLORS	2				/* ^[Qbg̐FiNA܂܂j */
///#define LEVEL_QUOTA	(FIELD_COLS*FIELD_ROWS/2)	/* ^[QbgNAH */
///#define LEVEL_SPEED	((1<<16)/SEC(0.5))		/* tB[h~Xs[hBubNPʂŏ16rbg */
///#define LEVEL_SPEED2	((1<<16)/SEC(2))		/* 댯][Ƀ^[Qbgꍇ̃tB[h~Xs[h */
#define LEVEL_COLORS	(gi.level->colors)		/* ^[Qbg̐FiNA܂܂j */
#define LEVEL_QUOTA	(gi.level->quota)		/* ^[QbgNAH */
#define LEVEL_SPEED	(gi.level->speed)		/* tB[h~Xs[hBubNPʂŏ16rbg */
#define LEVEL_SPEED2	(gi.level->speed2)		/* 댯][Ƀ^[Qbgꍇ̃tB[h~Xs[h */

typedef struct _LEVEL {
	int colors;	/* ^[Qbg̐FiNA܂܂j */
	int quota;	/* ^[QbgNAH */
	int speed;	/* tB[h~Xs[hBubNPʂŏ16rbg */
	int speed2;	/* 댯][Ƀ^[Qbgꍇ̃tB[h~Xs[h */
} LEVEL;
#define QUOTA_DEF(a)	((int)(FIELD_COLS*FIELD_ROWS*(a)))	/* ʕNA^[QbgoH */
#define SPEED_DEF(a)	((1<<16)/SEC(a))			/* b1ubN~H */
#define N_STAGE	8 /* {1Xe[W5Eh8Xe[W܂ŁB8Xe[Ŵ݃Eh6Ă̌NAȂ̂łǁc */
#define N_ROUND	5
LEVEL level_tbl[N_STAGE][N_ROUND] = {
	{{2,QUOTA_DEF(1.00),SPEED_DEF(3.000),SPEED_DEF(4.00*2)},
	 {3,QUOTA_DEF(1.00),SPEED_DEF(3.000),SPEED_DEF(4.00*2)},
	 {3,QUOTA_DEF(1.50),SPEED_DEF(2.500),SPEED_DEF(3.50*2)},
	 {4,QUOTA_DEF(1.50),SPEED_DEF(2.500),SPEED_DEF(3.50*2)},
	 {4,QUOTA_DEF(2.00),SPEED_DEF(2.000),SPEED_DEF(3.00*2)}},

	{{2,QUOTA_DEF(2.00),SPEED_DEF(3.000),SPEED_DEF(3.00*2)},
	 {3,QUOTA_DEF(2.00),SPEED_DEF(3.000),SPEED_DEF(3.00*2)},
	 {3,QUOTA_DEF(2.25),SPEED_DEF(2.500),SPEED_DEF(2.50*2)},
	 {4,QUOTA_DEF(2.25),SPEED_DEF(2.500),SPEED_DEF(2.50*2)},
	 {4,QUOTA_DEF(2.50),SPEED_DEF(2.000),SPEED_DEF(2.00*2)}},

	{{2,QUOTA_DEF(2.50),SPEED_DEF(2.000),SPEED_DEF(3.00*2)},
	 {3,QUOTA_DEF(2.50),SPEED_DEF(2.000),SPEED_DEF(3.00*2)},
	 {3,QUOTA_DEF(2.75),SPEED_DEF(1.500),SPEED_DEF(2.50*2)},
	 {4,QUOTA_DEF(2.75),SPEED_DEF(1.500),SPEED_DEF(2.50*2)},
	 {4,QUOTA_DEF(3.00),SPEED_DEF(1.000),SPEED_DEF(2.00*2)}},

	{{2,QUOTA_DEF(3.00),SPEED_DEF(2.000),SPEED_DEF(2.00*2)},
	 {3,QUOTA_DEF(3.00),SPEED_DEF(2.000),SPEED_DEF(2.00*2)},
	 {3,QUOTA_DEF(3.25),SPEED_DEF(1.500),SPEED_DEF(1.50*2)},
	 {4,QUOTA_DEF(3.25),SPEED_DEF(1.500),SPEED_DEF(1.50*2)},
	 {4,QUOTA_DEF(3.50),SPEED_DEF(1.000),SPEED_DEF(1.00*2)}},

	{{2,QUOTA_DEF(3.50),SPEED_DEF(1.000),SPEED_DEF(2.00*2)},
	 {3,QUOTA_DEF(3.50),SPEED_DEF(1.000),SPEED_DEF(2.00*2)},
	 {3,QUOTA_DEF(3.75),SPEED_DEF(0.750),SPEED_DEF(1.50*2)},
	 {4,QUOTA_DEF(3.75),SPEED_DEF(0.750),SPEED_DEF(1.50*2)},
	 {4,QUOTA_DEF(4.00),SPEED_DEF(0.500),SPEED_DEF(1.00*2)}},

	{{2,QUOTA_DEF(4.00),SPEED_DEF(1.000),SPEED_DEF(1.00*2)},
	 {3,QUOTA_DEF(4.00),SPEED_DEF(1.000),SPEED_DEF(1.00*2)},
	 {3,QUOTA_DEF(4.25),SPEED_DEF(0.750),SPEED_DEF(0.75*2)},
	 {4,QUOTA_DEF(4.25),SPEED_DEF(0.750),SPEED_DEF(0.75*2)},
	 {4,QUOTA_DEF(4.50),SPEED_DEF(0.500),SPEED_DEF(0.50*2)}},
		      
	{{2,QUOTA_DEF(4.50),SPEED_DEF(0.500),SPEED_DEF(1.00*2)},
	 {3,QUOTA_DEF(4.50),SPEED_DEF(0.500),SPEED_DEF(1.00*2)},
	 {3,QUOTA_DEF(4.75),SPEED_DEF(0.300),SPEED_DEF(0.75*2)},
	 {4,QUOTA_DEF(4.75),SPEED_DEF(0.300),SPEED_DEF(0.75*2)},
	 {4,QUOTA_DEF(5.00),SPEED_DEF(0.200),SPEED_DEF(0.50*2)}},

	{{2,QUOTA_DEF(5.00),SPEED_DEF(0.200),SPEED_DEF(0.50*2)},
	 {3,QUOTA_DEF(5.00),SPEED_DEF(0.200),SPEED_DEF(0.50*2)},
	 {3,QUOTA_DEF(5.25),SPEED_DEF(0.100),SPEED_DEF(0.50*2)},
	 {4,QUOTA_DEF(5.25),SPEED_DEF(0.100),SPEED_DEF(0.50*2)},
	 {4,QUOTA_DEF(5.50),SPEED_DEF(0.050),SPEED_DEF(0.50*2)}},
};

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

extern const unsigned char PAT[];
extern const unsigned char BG[];
TEXTURE pat;
TEXTURE bg;

int hiscore;
int stage_sel;
int round_sel;
GI gi;

/* Aj[V\̒S̋ */
const unsigned char explosion_pos[] = {
	0,
	0+3,
	0+3+3,
	0+3+3+2,
	0+3+3+2+2,
	0+3+3+2+2+1,
	0+3+3+2+2+1+1,
	0+3+3+2+2+1+1+0,
};
#define EXPLOSION_CNT	(sizeof explosion_pos / sizeof *explosion_pos) /* \ */

/* orŃ^C~O */
#define BASE_DELAY	SEC(0.2)	/* ŏ̔orłJn܂ł̃fBC */
#define DELAY_UNIT	SEC(0.1)	/* ׂ荇orł̊Ԋu */
#define DELAY_UNIT2	SEC(0.3)	/* NA̔fBC */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();
void grouping();
int field_erase();
int field_fall();
void field_down();
int bad_form();
int erase_check(int delay_mode, int base_col, int base_row);
void field_disp(int sight_disp);

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init(&render, &surface, 0, 0, 0, 0, 0, 0, 0);

#ifdef USE_MUSIC
	/* hFǂݍ݂܂B */
	if(loadInst() != 0) {
		int i, x, y;
		memset(vbuff, 3, sizeof vbuff);
		x = (DISP_X - 10 * 8) / 2;
		y = (DISP_Y - 10 * 2) / 2;
		render_string(&render, x, y, "drum.binǍs", 0, 0);
		y += 10;
		render_string(&render, x, y, "щ͖܂", 0, 0);
		for(i = 0; i < SEC(3); i++) {
			schedule();
			if(joy & (TRG_A | TRG_B)) break;
		}
	}
	/* yCu܂B */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

/*{{AvP[VL̏*/
	//srand(pceTimerGetCount());
	/* rbg}bvB */
	texture_init(&pat, PAT);
	texture_init(&bg, BG);
/*}}AvP[VL̏*/
	turbo(1);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
	turbo(0);
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
#endif /*USE_MUSIC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int i, x, y, sel = 0;

	for(;;) {
		schedule();

		/* X^[gHIH */
		if(joy & TRG_A     ) break;
		if(joy & TRG_SELECT) return -1;

		/* ʍĕ`ȂŃvvĝݓ_ł邽߁AʃNAɔI */
		memset(vbuff, 3, sizeof vbuff);

		/* Xe[WEEhIB */
		if(sel == 0) {
			if(joy & TRG_LF && stage_sel > 0          ) { stage_sel--; sound_play(CH_USR, SND_HIT); }
			if(joy & TRG_RI && stage_sel < N_STAGE - 1) { stage_sel++; sound_play(CH_USR, SND_HIT); }
			if(joy & TRG_DN) { sel = 1; sound_play(CH_USR, SND_HIT); }
		} else {
			if(joy & TRG_LF && round_sel > 0          ) { round_sel--; sound_play(CH_USR, SND_HIT); }
			if(joy & TRG_RI && round_sel < N_ROUND - 1) { round_sel++; sound_play(CH_USR, SND_HIT); }
			if(joy & TRG_UP) { sel = 0; sound_play(CH_USR, SND_HIT); }
		}

		/* ^Cg\B */
		x = (DISP_X - 10 * 5) / 2;
		y = 28;
		render_string_framed(&render, x, y, "ApY", 0, 0x210);
		x = (DISP_X - 10 * 8) / 2;
		y += 12;
		render_string_framed(&render, x, y, "Ȃă|bI", 0, 0x210);
		x = (DISP_X - 10 * 3) / 2;
		y += 12;
		render_string_framed(&render, x, y, "ǂ", 0, 0x210);

		/* XRA\B */
		x = 0;
		y = 0;
		render_string_framed(&render, x, y, "HISCORE", 0, 0x321);
		y += 10;
		render_printf_framed(&render, x, y, 0, 0x321, "%6d", hiscore <= 999999 ? hiscore : 999999);
		x = DISP_X - 5 * 7 - 3;
		y = 0;
		render_string_framed(&render, x, y, "PLAYER1", 0, 0x321);
		y += 10;
		render_printf_framed(&render, x, y, 0, 0x321, "%6d", gi.score <= 999999 ? gi.score : 999999);

		/* Xe[WEEhIB */
		x = (DISP_X - 5 * 12) / 2;
		y = DISP_Y - 20;
		if(sel == 0) {
			render_printf_framed(&render, x, y, 0, 0x321, "< STAGE  %d >", stage_sel + 1);
		} else {
			render_printf_framed(&render, x, y, 0, 0x332, "  STAGE  %d  ", stage_sel + 1);
		}
		y += 10;
		if(sel == 1) {
			render_printf_framed(&render, x, y, 0, 0x321, "< ROUND %2d >", round_sel + 1);
		} else {
			render_printf_framed(&render, x, y, 0, 0x332, "  ROUND %2d  ", round_sel + 1);
		}

		/* vvg\B */
		x = (DISP_X - 5 * 8) / 2;
		y = DISP_Y - 50;
		render_string_framed(&render, x, y, " A START", 0, 0x321);
		y += 10;
		render_string_framed(&render, x, y, "SEL EXIT", 0, 0x321);
	}

	/* vvg_ŁB */
	sound_play(CH_SYS, SND_CLEAR_GEN);
	for(i = 0; i < SEC(1.5); i++) {
		schedule();
		x = (DISP_X - 5 * 8) / 2;
		y = DISP_Y - 50;
		render_string_framed(&render, x, y, " A START", 0, i % SEC(0.5) < SEC(0.25) ? 0x333 : 0x321);
	}

	return 0;
}

/****************************************************************************
 *	game
 ****************************************************************************/

static void
game_init()
{
	/* Q[ϐNAB */
	memset(&gi, 0, sizeof gi);
	gi.stage = stage_sel;
	gi.round = round_sel;
	gi.seed = pceTimerGetCount();
}

static void
round_init()
{
	int i;

	/* x|C^ݒB */
	i = gi.stage < N_STAGE ? gi.stage : N_STAGE - 1;
	gi.level = &level_tbl[i][gi.round];

	/* EhϐNAB */
	gi.down_time = 0;
	gi.erase_cnt = 0;
	gi.clear_gen = 0;
	gi.combo = 0;
	memset(&gi.player, 0, sizeof(PLAYER));
	memset(&gi.shot, 0, sizeof(SHOT));
	memset(gi.field, 0, sizeof gi.field);

	/* ^[QbgB */
	for(i = 0; i < 3; i++) field_down(); /*̒grouping()Ă΂܂*/

	/* vC[ʒuݒB */
	gi.player.col = FIELD_COLS / 2;
}

static void
player_work()
{
	/* EړB */
	if((joy & TRG_LF) && (gi.player.col >              0)) gi.player.col--;
	if((joy & TRG_RI) && (gi.player.col < FIELD_COLS - 1)) gi.player.col++;

	/* ̖߂B */
	if(gi.player.stat == PLAYER_STAT_SHOT) {
		if(gi.player.cnt < 2) gi.player.cnt++;
		if(gi.player.cnt >= 2) {
			gi.player.stat = 0;
			gi.player.cnt = 0;
		}
	}
}

void
game()
{
	int i, x, y, col, row, spd;
	CELL* cell;
	unsigned char* p;

	game_init();
	for(;;) {
		/* EhB */
		round_init();
		music_play(BGM1);

		/* uQ[X^[gv */
		for(i = 0; i < SEC(2); i++) {
			schedule();
			field_disp(1);
			if(i >= SEC(0.5)) {
				x = (DISP_X - (10 * 7 + 2)) / 2;
				y = (DISP_Y - (10 + 2)) / 2;
				render_string_framed(&render, x, y, "Q[X^[g", 0, 0x231);
			}
		}

L_NORMAL_PHASE:	/*-------------------- ʏtF[Y --------------------*/
		gi.combo = 0; /* ANA */
		for(;;) {
			schedule();

			/* vC[B */
			player_work();

			/* A܂B{^ꂽAݔ˒̃Vbg[VLZB */
			if(joy & (TRG_A | TRG_B)) {
				if(gi.shot.stat) {
					gi.shot.row = 0;
				}
			}

			/* VbgړB */
			if(gi.shot.stat) {
				if(gi.shot.row > 0) gi.shot.row--; /* ̃[VLZ0ɂĂꍇ̂ŁA>0 Kv */
				/* qbgʒuB݈ʒü̃^[QbgEp[cA[Ƀqbgł܂B */
				col = gi.shot.col;
				for(row = FIELD_ROWS - 1; row >= 0; row--) {
					if(row < gi.shot.row - 1) goto L_SHOT_NOHIT; /* qbgȂ */
					if(gi.field[row][col].type) break; /* qbgI */
				}
				/* row = ̃^[QbgEp[cɃqbgꍇ͂̃^[QbgEp[c̈ʒuB
				 *       [Ƀqbgꍇ-1ɂȂĂ܂B
				 */
				/* ŉĩ^[Qbgorp[ciۂɂ̓p[c肦ȂjɃqbgꍇ́Ảł܂B
				 * VbgꍇiԂAFmÕVbgVɌ񂾁j̉ł܂B
				 */
				if(row == FIELD_ROWS - 1 || /* ŉiɃ^[Qbgorp[c */
				   gi.shot.color == SHOT_COLOR_INVALID) { /* Vbg */
					memset(&gi.shot, 0, sizeof(SHOT)); /* Vbg͏ */
					goto L_SHOT_NOHIT;
				}
				/* qbg炵܂B */
				sound_play(CH_USR, SND_HIT);
				/* qbgΏۂ̒Ƀp[c̉܂B */
				row++;
				cell = &gi.field[row][col];
				memset(cell, 0, sizeof(CELL));
				cell->type = CELL_TYPE_PARTS;
				cell->color = gi.shot.color;
				/* ㉺EɓF̃^[Qbgorp[c΁Aŏɔ̂ƓO[vԍ̗p܂B
				 * Ȃ΁A^[QbgƂO[sO͂łȂ̂ŁAO[vԍ0̂܂܂Ƃ܂B
				 */
				       if(col > 0 &&
				   (gi.field[row][col - 1].type == CELL_TYPE_TARGET || gi.field[row][col - 1].type == CELL_TYPE_PARTS) &&
				   gi.field[row][col - 1].color == gi.shot.color) {
					cell->group = gi.field[row][col - 1].group;
				} else if(row > 0 &&
				   (gi.field[row - 1][col].type == CELL_TYPE_TARGET || gi.field[row - 1][col].type == CELL_TYPE_PARTS) &&
				   gi.field[row - 1][col].color == gi.shot.color) {
					cell->group = gi.field[row - 1][col].group;
				} else if(col < FIELD_COLS - 1 &&
				   (gi.field[row][col + 1].type == CELL_TYPE_TARGET || gi.field[row][col + 1].type == CELL_TYPE_PARTS) &&
				   gi.field[row][col + 1].color == gi.shot.color) {
					cell->group = gi.field[row][col + 1].group;
				} else if(row < FIELD_ROWS - 1 &&
				   (gi.field[row + 1][col].type == CELL_TYPE_TARGET || gi.field[row + 1][col].type == CELL_TYPE_PARTS) &&
				   gi.field[row + 1][col].color == gi.shot.color) {
					cell->group = gi.field[row + 1][col].group;
				}
				memset(&gi.shot, 0, sizeof(SHOT)); /* Vbg͏ */
				/* Ń`FbNB */
				switch(erase_check(0/*ˏɏ*/, col, row)) {
				case 1:
					/* łAŃtF[Y */
					field_disp(0);
					goto L_ERASE_PHASE;
				case 2:
					/* NA^[QbgłANAցB */
					field_disp(0);
					goto L_CLEAR;
				}
				/* ăO[sOB
				 * KvłIȂƁA^[QbgɌĐLтĂp[cA^[QbgɂȂȂ܂B
				 */
				grouping();
L_SHOT_NOHIT:
			}

			/* A{^ꂽVbgˁB */
			if(joy & TRG_A) {
				if(!gi.shot.stat) {
					/* Vbg炵܂B */
					sound_play(CH_USR, SND_SHOT);
					/* }[NB */
					gi.player.stat = PLAYER_STAT_SHOT;
					gi.player.cnt = 0;
					/* VbglݒB */
					memset(&gi.shot, 0, sizeof(SHOT));
					gi.shot.stat = 1;
					gi.shot.col = gi.player.col;
					gi.shot.row = FIELD_ROWS - 1;
					/* ʏɊɃp[c΁Ãp[cƓFB */
					for(row = 0; row < FIELD_ROWS; row++) {
						for(col = 0; col < FIELD_COLS; col++) {
							cell = &gi.field[row][col];
							if(cell->type == CELL_TYPE_PARTS) {
								gi.shot.color = cell->color;
								goto L_SHOT_COLOR;
							}
						}
					}
					/* ʏɃp[cȂ΁Ä݂̗ԉɂ^[Qbg̐FB */
					col = gi.shot.col;
					for(row = FIELD_ROWS - 1; row >= 0; row--) {
						cell = &gi.field[row][col];
						if(cell->type == CELL_TYPE_TARGET) {
							gi.shot.color = cell->color;
							goto L_SHOT_COLOR;
						}
					}
					/* ݂̗Ƀ^[QbgȂ΁AVbgB */
					gi.shot.color = SHOT_COLOR_INVALID;
L_SHOT_COLOR:
				}
			}

			/* B{^ꂽp[cLZB */
			if(joy & TRG_B) {
				for(row = 0; row < FIELD_ROWS; row++) {
					for(col = 0; col < FIELD_COLS; col++) {
						cell = &gi.field[row][col];
						if(cell->type == CELL_TYPE_PARTS) {
							memset(cell, 0, sizeof(CELL));
						}
					}
				}
			}

			/* ŉïɃ^[QbgȂԂŉ{^ꂽA~BiƎdlIj */
			if(joy & TRG_DN) {
				row = FIELD_ROWS - 2;
				for(col = 0; col < FIELD_COLS; col++) {
					cell = &gi.field[row][col];
					if(cell->type == CELL_TYPE_TARGET) break;
				}
				if(col == FIELD_COLS) goto L_FIELD_DOWN;
			}

			/* tB[h~B */
			spd = LEVEL_SPEED;
			for(row = FIELD_ROWS - 3; row <= FIELD_ROWS - 2; row++) { /* ŉi̓ƈ̃C𑖍 */
				for(col = 0; col < FIELD_COLS; col++) {
					cell = &gi.field[row][col];
					if(cell->type == CELL_TYPE_TARGET) {
						spd = LEVEL_SPEED2;
						break;
					}
				}
				if(col < FIELD_COLS) break;
			}
			gi.down_time += spd;
			if(gi.down_time >= (1 << 16)) {
L_FIELD_DOWN:
				/* tB[h~B */
				field_down(); /*̒grouping()Ă΂܂*/
				/* ΂񉺂ɂ^[Qbg̍sB */
				for(row = FIELD_ROWS - 1; row >= 0; row--) {
					for(col = 0; col < FIELD_COLS; col++) {
						cell = &gi.field[row][col];
						if(cell->type == CELL_TYPE_TARGET) break; /* ^[QbgbreakIp[c͊֌WȂ */
					}
					if(col < FIELD_COLS) break;
				}
				/* ŉiɃ^[QbgQ[I[o[B */
				if(row == FIELD_ROWS - 1) {
					field_disp(0);
					goto L_GAMEOVER;
				}
				/* ŉi̓(FIELD_ROWS-3)ɂAxB
				 * łȂ΁Aʏ̃tB[h~B
				 * ŉi̓ォ(FIELD_ROWS-2)ɍ~Ăꍇ͒ʏ̍~ł邱ƂɒӁI
				 */
				if(row == FIELD_ROWS - 3) {
					sound_play(CH_ENV, SND_WARNING);
				} else {
					sound_play(CH_ENV, SND_DOWN);
				}
				/* tB[h~^C}ZbgB */
				gi.down_time = 0;
			}

			/* \XVB */
			field_disp(1);
		}

L_ERASE_PHASE:	/*-------------------- ŃtF[Y --------------------*/
		gi.combo++; /* AJEgAbv */
		for(;;) {
			schedule();

			///ȒP̂ŃI
			////* ~JE^߂BiƎdlIj */
			///if(gi.down_time > 0) {
			///	gi.down_time -= (1 << (16 - 4));
			///	if(gi.down_time < 0) gi.down_time = 0;
			///}

			/* vC[B */
			player_work();

			/* ŏBAtF[YցB */
			if(!field_erase()) {
				/* ōăO[sOKvłI
				 * tF[YŃtF[YֈڍsꍇAƂƓO[v^[Qbg
				 * ɂĕAʁX̃^[QbgɂȂĂ邩mȂłB
				 * ̗JnOɍăO[sOĂȂƁA
				 * O[vĂт󋵂ŏłȂȂ܂Bił̂j
				 */
				grouping();
				field_disp(0);
				goto L_FALL_PHASE;
			}

			/* \XVB */
			field_disp(0);
		}

L_FALL_PHASE:	/*-------------------- tF[Y --------------------*/
		for(;;) {
			schedule();

			///ȒP̂ŃI
			////* ~JE^߂BiƎdlIj */
			///if(gi.down_time > 0) {
			///	gi.down_time -= (1 << (16 - 4));
			///	if(gi.down_time < 0) gi.down_time = 0;
			///}

			/* vC[B */
			player_work();

			/* B... */
			if(!field_fall()) {
				/* AŃ`FbNB */
				switch(erase_check(1/*sɏ*/, 0, 0)) {
				case 1:
					/* łAŃtF[YցB */
					field_disp(0);
					goto L_ERASE_PHASE;
				case 2:
					/* NA^[QbgłANAցB
					 * ۂɂ́ANA^[Qbgׂ͗荇ďoȂ̂ŁAAŏ邱Ƃ͂Ȃ͂AɔĈꉞB
					 */
					field_disp(0);
					goto L_CLEAR;
				}
				/* łȂ΁AăO[sOāAʏtF[YցB */
				grouping();
				field_disp(0);
				goto L_NORMAL_PHASE;
			}

			/* \XVB */
			field_disp(0);
		}
L_CLEAR:
		music_stop();
		/* ł̂҂܂B */
		for(i = 0; ; i++) {
			schedule();
			if(!field_erase()) {
				field_disp(0);
				break;
			}
			field_disp(0);
			if(i >= SEC(1)) {
				x = (DISP_X - (10 * 7 + 2)) / 2;
				y = (DISP_Y - (10 + 2)) / 2;
				render_string_framed(&render, x, y,
					gi.round < N_ROUND - 1 ? "EhNA" : "Xe[WNA",
					0, 0x231);
			}
		}
		field_disp(0);
		x = (DISP_X - (10 * 7 + 2)) / 2;
		y = (DISP_Y - (10 + 2)) / 2;
		render_string_framed(&render, x, y,
			gi.round < N_ROUND - 1 ? "EhNA" : "Xe[WNA",
			0, 0x231);
		/* uEhNAv */
		for(i = 0; i < SEC(3); i++) {
			schedule();
			if(i >= SEC(1) && joy & (TRG_A | TRG_B)) break;
		}

		/* EhorXe[Wi߂B */
		if(gi.round < N_ROUND - 1) {
			gi.round++;
		} else {
			gi.stage++;
			gi.round = 0;
		}
	}

L_GAMEOVER:
	/* uQ[I[o[v */
	music_stop();
	sound_play(CH_SYS, SND_GAMEOVER);
	memset(&gi.shot, 0, sizeof(SHORT));
	for(i = 124; i >= 20; i -= 4) {
		schedule();
		field_disp(0);
		for(y = i; y <= 124; y++) {
			p = &vbuff[DISP_X * y + 6];
			for(x = 6; x <= 80; x++) {
				if(*p) (*p)--;
				p++;
			}
		}
	}
	x = (DISP_X - (10 * 7 + 2)) / 2;
	y = (DISP_Y - (10 + 2)) / 2;
	render_string_framed(&render, x, y, "Q[I[o[", 0, 0x231);
	for(i = 0; i < SEC(3); i++) {
		schedule();
		if(i >= SEC(1) && joy & (TRG_A | TRG_B)) break;
	}

	/* nCXRAXVB */
	if(gi.score > hiscore) hiscore = gi.score;
}

/****************************************************************************
 *	grouping
 ****************************************************************************/

/* ő(FIELD_COLS*FIELD_ROWS)ċÂŁAX^bN傫߂ɎĂB
 * AZu\[XŊmFƂA̍ċA12oCgx悤łB
 * Ȃ]TĈ32oCgƉ肷ƁAő32*99=3168oCgB
 * ]āAʏ̃X^bN4KBɉāA4KBĂΏ[Ǝv܂B
 * MakefileSTACKLEN=0x1000STACKLEN=0x2000ɕύXĂB
 */

/* O[v쐬ꂽ0ȊO̒lԂ܂B
 * ̓O[ṽ^[Qbgorp[cԂĂ̂łÂ݂Ƃ됔͊֌W܂B
 */
static int
grouping_sub(int group, int col, int row, int color)
{
	int cnt;
	CELL* cell;

	/* tB[hOȂ牽܂B */
	if(col < 0 || FIELD_COLS - 1 < col) return 0;
	if(row < 0 || FIELD_ROWS - 1 < row) return 0;

	/* Z擾܂B */
	cell = &gi.field[row][col];

	/* ^[Qbg܂̓p[cłȂΉ܂B */
	switch(cell->type) {
	case CELL_TYPE_TARGET:
	case CELL_TYPE_PARTS:
		break;
	default:
		return 0;
	}

	/* F牽܂B */
	if(cell->color != color) return 0;

	/* ɃO[vԍݒ肳Ă牽܂B */
	if(cell->group) return 0;

	/* O[vԍݒ肵܂B */
	cell->group = group;

	/* ㉺ẼZɍċA܂B */
	cnt = 1;
	cnt += grouping_sub(group, col - 1, row, color);
	cnt += grouping_sub(group, col + 1, row, color);
	cnt += grouping_sub(group, col, row - 1, color);
	cnt += grouping_sub(group, col, row + 1, color);
	return cnt;
}

void
grouping()
{
	int group, col, row;
	CELL* cell;

	/* ܂tB[hŜ̃O[vԍNA܂B */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &gi.field[row][col];
			cell->group = 0;
		}
	}

	/* SẴZɂ... */
	group = 1; /* O[vԍ1 */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &gi.field[row][col];
			switch(cell->type) {
			/* O[sO̊_̓^[Qbĝ݁Ip[cł̓O[sO܂B */
			case CELL_TYPE_TARGET:
				if(grouping_sub(group, col, row, cell->color)) {
					/* O[v`ꂽAO[vԍ֐i߂܂B */
					group++;
				}
				break;
			}
		}
	}
}

/****************************************************************************
 *	field_erase
 ****************************************************************************/

/* tB[h̃^[QbgEp[cŏB
 * ^[QbgEp[c̏łisȂA0ȊO̒lԂ܂B
 * łA0Ԃ܂B
 */
int
field_erase()
{
	int col, row, erase, snd;
	CELL* cell;

	/* tB[hŜ𑖍... */
	erase = 0; /* łŐisĂA1Zbg܂ */
	snd = 0; /* 炷ꍇ́A1Zbg܂ */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &gi.field[row][col];
			switch(cell->type) {
			case CELL_TYPE_TARGET:
				if(cell->stat == CELL_STAT_ERASE) {
					erase = 1; /* Őis */
					if(cell->cnt > 0) cell->cnt--;
					if(cell->cnt <= 0) {
						memset(cell, 0, sizeof(CELL));
						cell->type = CELL_TYPE_EXPLOSION;
						snd = 1; /* Ƃł܂Ƃ߂ăTEh炵܂ */
						/* _ZEŃJEgAbvB */
						gi.score += gi.combo; /* 1^[QbgAA[_] */
						gi.erase_cnt++;
					}
				}
				break;
			case CELL_TYPE_PARTS:
				if(cell->stat == CELL_STAT_ERASE) {
					erase = 1; /* Őis */
					if(cell->cnt > 0) cell->cnt--;
					if(cell->cnt <= 0) {
						memset(cell, 0, sizeof(CELL));
					}
				}
				break;
			case CELL_TYPE_EXPLOSION:
				erase = 1; /* Őis */
				if(cell->cnt < EXPLOSION_CNT) {
					cell->cnt++;
				} else {
					memset(cell, 0, sizeof(CELL));
				}
				break;
			}
		}
	}
	/* 甚炵܂B */
	if(snd) sound_play(CH_ENV, SND_EXPLOSION);

	return erase;
}

/****************************************************************************
 *	field_fall
 ****************************************************************************/

/* tB[h̃^[Qbgizg͏㏸łIȉljB
 * ^[QbgłA0ȊO̒lԂ܂B
 * ̊֐ł͍ăO[sOsȂ̂ŁAĂяoōsĂB
 */
int
field_fall()
{
	int col, row, fall, snd;
	CELL* cell;

	/* tB[h̊eォ牺֏cɑA\ȃ^[QbgT܂B */
	fall = 0; /* łA1Zbg܂ */
	snd = 0; /* n炷ꍇ́A1Zbg܂ */
	for(col = 0; col < FIELD_COLS; col++) {
		for(row = 1/*ŏi͑Ȃ*/; row < FIELD_ROWS; row++) {
			cell = &gi.field[row][col];
			if(!cell->type) continue; /* 󂫃Z͔΂܂ */
			if(gi.field[row - 1][col].type) continue; /* オ󂫃ZłȂΗs */
			/* ^[QbgƂ}[N܂B */
			fall = 1;
			/* Z̏オŏiA܂͂̏ɕʂ̃^[Qbg΁AƂŒn炷߁A}[NĂ܂B */
			if(row < 2 || gi.field[row - 2][col].type) snd = 1;
			/* Â֋l߂܂B */
			while(row < FIELD_ROWS) {
				gi.field[row - 1][col] = gi.field[row][col];
				row++;
			}
			/* ŉi󂫃Zɂ܂B */
			memset(&gi.field[row - 1][col], 0, sizeof(CELL));
			/* ŁArow=FIELD_ROWSɂȂĂ̂ŁȂ̗͒ɔ܂B
			 * ȂƁAɋ󂫃ZꍇÂق̃Z1t[2ZȏړĂ܂܂B
			 */
		}
	}
	/* n璅n炵܂B */
	if(snd) sound_play(CH_ENV, SND_FALL);

	return fall;
}

/****************************************************************************
 *	field_down
 ****************************************************************************/

/* tB[hiAŏiɐV^[Qbg𐶐܂B
 * ̊֐ōăO[sOŝŁAĂяoł͕Kv܂B
 */
void
field_down()
{
#define MAX_RETRY	10

	int col, col2, retry;
	CELL* cell;
	int clear_gen = 0;

	/* iֈړB */
	memmove(&gi.field[1][0], &gi.field[0][0], sizeof(CELL) * FIELD_COLS * (FIELD_ROWS - 1));

	for(retry = 0; retry < MAX_RETRY; retry++) {
		/* ŏiɐV^[Qbg𐶐B */
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &gi.field[0][col];
			memset(cell, 0, sizeof(CELL));
			cell->type = CELL_TYPE_TARGET;
			cell->color = RND16(gi.seed) % LEVEL_COLORS;
		}

		/* ^[QbgŐK萔ɒBAxNA^[Qbg𐶐B */
		if(gi.erase_cnt >= LEVEL_QUOTA && !gi.clear_gen) {
			/* ڂ̃NA^[Qbg𐶐B */
			col = RND16(gi.seed) % FIELD_COLS;
			gi.field[0][col].color = CELL_COLOR_CLEAR;
			/* ڂ̃NA^[Qbg𐶐Bڂׂ̗͕sB */
			for(;;) {
				col2 = RND16(gi.seed) % FIELD_COLS;
				if(abs(col - col2) > 1) {
					gi.field[0][col2].color = CELL_COLOR_CLEAR;
					break;
				}
			}
			/* NA^[Qbg𐶐Ƃ}[NBgi.clear_genւ̃}[N͌ŁB */
			clear_gen = 1;
		}

		/* ăO[sOB */
		grouping();

		/* l܂ɂȂ\̂`łȂ΁A̗pĔB
		 * l܂ɂȂ\̂`ȂA񐔂܂ŃgCB
		 */
		if(!bad_form()) break;
	}

	/* NA^[QbǧʉƁAۂɃ}[NB */
	if(clear_gen) {
		sound_play(CH_SYS, SND_CLEAR_GEN);
		gi.clear_gen = 1;
	}
}

/****************************************************************************
 *	bad_form
 ****************************************************************************/

/* `̔fASY
 *
 * ʍ[E[܂ŁAeFPO[vȓoRɓBł爫`B
 * \ʉĎl܂ɂȂ\AƌȂ܂B
 *
 * ܂ƂɃZPʂőƁȂɐ\bĂ܂܂B
 * ܂O[vPʂ̗אڃOtĂ瑖΁A50gC1`2b炢HɎ܂܂B
 * ۂɂ50gCȂĂ肦Ȃ̂ŁA[ȑxƎv܂B
 * î݂ƂAfield_down()̒10gCɐݒ肵Ă܂B10΂Ԃǌ`ɓł傤j
 *
 * [ȑxĂƎv̂ŁArbgtB[h͍̍s܂łB
 * ƑxKvȂAItZbgƃrbg}XNɕĂ镔A
 * 32rbg~4̃[vɓWJ΁A炩ȂƎv܂B
 */

static unsigned char group_color[256];		/* [O[v] -> F */
static unsigned char group_right[256 / 8];	/* E[ɂO[ṽrbg}XN */
static unsigned char group_chain[256][256 / 8];	/* [O[v] -> ̃O[vɗאڂO[ṽrbg}XN */

static int bad_form_sub(int group, int color_mask);

int
bad_form()
{
	int col, row;
	CELL *cell, *cell2;

	/* e[uƃrbgtB[hB */
	memset(group_color, 0, sizeof group_color);
	memset(group_chain, 0, sizeof group_chain);
	memset(group_right, 0, sizeof group_right);
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &gi.field[row][col];
			if(cell->type != CELL_TYPE_TARGET) continue; /* ^[QbgȊO͖ */

			/* ̃O[v̐Fi[Bii[ĂSēF̂͂j */
			group_color[cell->group] = cell->color;

			/* E[ȂÃO[ṽrbg𗧂ĂB */
			if(col == FIELD_COLS - 1) group_right[cell->group / 8] |= 1 << (cell->group % 8);

			/* ̃O[vɗאڂO[ṽrbg𗧂ĂB
			 * O[ṽrbgĂĂ܂č\܂B
			 * iƂO[vłAFȏʂbad_form_sub()Œe邩j
			 */
			if(col > 0) {
				cell2 = &gi.field[row][col + 1];
				if(cell2->type == CELL_TYPE_TARGET) group_chain[cell->group][cell2->group / 8] |= 1 << (cell2->group % 8);
			}
			if(col < FIELD_COLS - 1) {
				cell2 = &gi.field[row][col - 1];
				if(cell2->type == CELL_TYPE_TARGET) group_chain[cell->group][cell2->group / 8] |= 1 << (cell2->group % 8);
			}
			if(row > 0) {
				cell2 = &gi.field[row + 1][col];
				if(cell2->type == CELL_TYPE_TARGET) group_chain[cell->group][cell2->group / 8] |= 1 << (cell2->group % 8);
			}
			if(row < FIELD_ROWS - 1) {
				cell2 = &gi.field[row - 1][col];
				if(cell2->type == CELL_TYPE_TARGET) group_chain[cell->group][cell2->group / 8] |= 1 << (cell2->group % 8);
			}
		}
	}

	/* [ɂO[vX^[gāAeFPO[vȓŉE[ɓBł邩H */
	col = 0;
	for(row = 0; row < FIELD_ROWS; row++) {
		cell = &gi.field[row][col];
		if(cell->type != CELL_TYPE_TARGET) continue; /* ^[QbgȊO͖ */
		if(bad_form_sub(cell->group, 0)) return 1;
	}

	return 1;
}

static int
bad_form_sub(int group, int color_mask)
{
	int color, group2;

	/* ̃O[v̐F擾B */
	color = group_color[group];

	/* ɂ̐FʂĂAsB */
	if(color_mask & (1 << color)) return 0;

	/* E[̃O[vɓBA`mB */
	if(group_right[group / 8] |= 1 << (group % 8)) return 1;

	/* ̃O[vɗאڂ鎟̃O[vɍċAāA`ǂׂB */
	color_mask |= 1 << color; /* ݂̐F͂s */
	for(group2 = 1/*O[v#0͂Ȃ*/; group2 < 256; group2++) {
		if(group_chain[group][group2 / 8] |= 1 << (group2 % 8)) {
			if(bad_form_sub(group2, color_mask)) return 1; /* `ł */
		}
	}

	return 0; /* ǌ`ł */
}

/****************************************************************************
 *	erase_check
 ****************************************************************************/

static int
calc_delay(int delay_mode, int base_col, int base_row, int col, int row)
{
	int delay;

	switch(delay_mode) {
	case 0: /* ˏɏ */
		delay = BASE_DELAY +
			DELAY_UNIT * (abs(col - base_col) + abs(row - base_row));
		break;
	case 1: /* sɏ */
		delay = BASE_DELAY +
			DELAY_UNIT * abs(row - base_row);
		break;
	default:
		DIE();
	}

	return delay;
}

static void
mark_erase(int col, int row, int group)
{
	CELL* cell;

	/* tB[hOȂ牽܂B */
	if(col < 0 || FIELD_COLS - 1 < col) return;
	if(row < 0 || FIELD_ROWS - 1 < row) return;

	/* Z擾܂B */
	cell = &gi.field[row][col];

	/* ^[Qbg܂̓p[cłȂΉ܂B */
	switch(cell->type) {
	case CELL_TYPE_TARGET:
	case CELL_TYPE_PARTS:
		break;
	default:
		return;
	}

	/* O[vԍ牽܂B */
	if(cell->group != group) return;

	/* ɏŃ}[NĂ牽܂B */
	if(cell->stat == CELL_STAT_ERASE) return;

	/* Ń}[N܂B */
	cell->stat = CELL_STAT_ERASE;
	/* cnt͂ƂŁAerase_check()̒Őݒ肵܂B */

	/* ㉺ẼZɍċA܂B */
	mark_erase(col - 1, row, group);
	mark_erase(col + 1, row, group);
	mark_erase(col, row - 1, group);
	mark_erase(col, row + 1, group);
}

/* 0:łȂ
 * 1:ʏŔ
 * 2:NA^[Qbg
 */
int
erase_check(int delay_mode, int base_col, int base_row)
{
	int col, row, erase, clear, delay, delay_add;
	CELL *cell, *cell2;

	/* ʑŜ𑖍āAFEʃO[ṽ^[QbgEp[cׂ荇ĂAŃ}[N܂B
	 * ӁIO[v̏łoĂAʑŜ̂̃O[vԍ̃^[QbgĂ܂Ă͂܂B
	 *       Ɉ̃O[vĂQȏɕUĂ\邩łB
	 */
	erase = 0; /* łA1Zbg܂ */
	clear = 0; /* NA^[QbgłA1Zbg܂ */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &gi.field[row][col];
			switch(cell->type) {
			case CELL_TYPE_TARGET:
			case CELL_TYPE_PARTS:
				if(col > 0) {
					cell2 = &gi.field[row][col - 1];
					switch(cell2->type) {
					case CELL_TYPE_TARGET:
					case CELL_TYPE_PARTS:
						if(cell->color == cell2->color &&
						   cell->group != cell2->group &&
						   cell->group && cell2->group) { /* ^[QbgɂȂĂȂp[c͗LȃO[vƂ͌ȂȂ */
							mark_erase(col    , row, cell ->group);
							mark_erase(col - 1, row, cell2->group);
							erase = 1;
							if(cell->color == CELL_COLOR_CLEAR) clear = 1;
						}
						break;
					}
				}
				if(row > 0) {
					cell2 = &gi.field[row - 1][col];
					switch(cell2->type) {
					case CELL_TYPE_TARGET:
					case CELL_TYPE_PARTS:
						if(cell->color == cell2->color &&
						   cell->group != cell2->group &&
						   cell->group && cell2->group) { /* ^[QbgɂȂĂȂp[c͗LȃO[vƂ͌ȂȂ */
							mark_erase(col, row    , cell ->group);
							mark_erase(col, row - 1, cell2->group);
							erase = 1;
							if(cell->color == CELL_COLOR_CLEAR) clear = 1;
						}
						break;
					}
				}
				if(col < FIELD_COLS - 1) {
					cell2 = &gi.field[row][col + 1];
					switch(cell2->type) {
					case CELL_TYPE_TARGET:
					case CELL_TYPE_PARTS:
						if(cell->color == cell2->color &&
						   cell->group != cell2->group &&
						   cell->group && cell2->group) { /* ^[QbgɂȂĂȂp[c͗LȃO[vƂ͌ȂȂ */
							mark_erase(col    , row, cell ->group);
							mark_erase(col + 1, row, cell2->group);
							erase = 1;
							if(cell->color == CELL_COLOR_CLEAR) clear = 1;
						}
						break;
					}
				}
				if(row < FIELD_ROWS - 1) {
					cell2 = &gi.field[row + 1][col];
					switch(cell2->type) {
					case CELL_TYPE_TARGET:
					case CELL_TYPE_PARTS:
						if(cell->color == cell2->color &&
						   cell->group != cell2->group &&
						   cell->group && cell2->group) { /* ^[QbgɂȂĂȂp[c͗LȃO[vƂ͌ȂȂ */
							mark_erase(col, row    , cell ->group);
							mark_erase(col, row + 1, cell2->group);
							erase = 1;
							if(cell->color == CELL_COLOR_CLEAR) clear = 1;
						}
						break;
					}
				}
				break;
			}
		}
	}

	/* ł... */
	if(erase) {
		/* sŃ[h̊sB */
		if(delay_mode == 1) {
			for(row = 0; row < FIELD_ROWS; row++) {
				for(col = 0; col < FIELD_COLS; col++) {
					cell = &gi.field[row][col];
					if((cell->type == CELL_TYPE_TARGET ||
					    cell->type == CELL_TYPE_PARTS) &&
					   cell->stat == CELL_STAT_ERASE) {
						base_row = row;
						break;
					}
				}
				if(col < FIELD_COLS) break;
			}
		}
		/* Ń}[Nꂽ^[Qbg̃fBCvZƁASp[c̏Ń}[NB */
		for(row = 0; row < FIELD_ROWS; row++) {
			for(col = 0; col < FIELD_COLS; col++) {
				cell = &gi.field[row][col];
				switch(cell->type) {
				case CELL_TYPE_TARGET:
					/* Ń}[NĂ^[Qbg̃fBCvZB */
					if(cell->stat == CELL_STAT_ERASE) {
						cell->cnt = calc_delay(delay_mode, base_col, base_row, col, row);
					}
					break;
				case CELL_TYPE_PARTS:
					/* p[c͘A̗LɊւ炸ASďŁB */
					cell->stat = CELL_STAT_ERASE;
					cell->cnt = calc_delay(delay_mode, base_col, base_row, col, row);
					break;
				}
			}
		}
	}

	/* NA^[Qbg̏łAʏ̃^[QbgSāAA̗LɊ֌WȂiցjł}[N܂B */
	if(clear) {
		delay = BASE_DELAY;
		delay_add = 0;
		for(row = FIELD_ROWS - 1; row >= 0; row--) {
			for(col = 0; col < FIELD_COLS; col++) {
				cell = &gi.field[row][col];
				if(cell->type == CELL_TYPE_TARGET) {
					cell->stat = CELL_STAT_ERASE;
					cell->cnt = delay;
					delay_add = DELAY_UNIT2; /* ̍sɃfBCJn */
				}
			}
			delay += delay_add;
		}
	}

	/* clear=1ȂKerase=1Ȃ̂ŁA
	 * erase=0,clear=0 -> ߂l 0
	 * erase=1,clear=0 -> ߂l 1
	 * erase=1,clear=1 -> ߂l 2
	 * ƂȂ܂B
	 */
	return erase + clear;
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

#define DX_FIELD	7
#define DY_FIELD	21

#define SX_TARGET	0
#define SY_TARGET	0
#define SX_PARTS	0
#define SY_PARTS	63
#define SX_SHOT		0
#define SY_SHOT		108
#define SX_EXPLOSION	9
#define SY_EXPLOSION	108
#define SX_SIGHT	18
#define SY_SIGHT	108

#define DY_PLAYER	(DY_FIELD + 8 * 11 + 1)
#define SX_PLAYER	0
#define SY_PLAYER	130
#define W_PLAYER	11
#define H_PLAYER	14

#define DX_STAGE	16
#define DY_STAGE	5
#define DX_SCORE	50
#define DY_SCORE	5

#define X_DEADLINE	6
#define Y_DEADLINE	102
#define W_DEADLINE	72
#define H_DEADLINE	2

#define X_ARROW		40
#define Y_ARROW		5
#define W_ARROW		7
#define H_ARROW		13

unsigned char dash_ptn[] = { 3,2,1,0 }; /* Əp̔jp^[ */

void
field_disp(int sight_disp)
{
	int col, row, dx, dy, sx, sy, ptn;
	CELL *cell, *cell2;

	render.context->texture = &bg; //////////////////////////////////////

	/* wi\B */
	render_object(&render, 0, 0, 0, 0, DISP_X, DISP_Y, DRW_NOMAL);

	/* Xe[WEEhEXRA\B */
	render_printf(&render, DX_STAGE, DY_STAGE, 0, 0, "%d-%d",
		(gi.stage + 1) <= 9 ? (gi.stage + 1) : 9,
		(gi.round + 1) <= 9 ? (gi.round + 1) : 9);
	render_printf(&render, DX_SCORE, DY_SCORE, 0, 0, "%5d",
		gi.score <= 99999 ? gi.score : 99999);

	/* tB[h~CWP[^}XNB */
	if(gi.down_time < 0) {
		ptn = 0;
	} else if(gi.down_time < (1 << 16)) {
		ptn = gi.down_time;
	} else {
		ptn = 1 << 16;
	}
	ptn = (H_ARROW * ptn + (1 << 15)) >> 16;
	dx = X_ARROW;
	dy = Y_ARROW + ptn;
	render_rectangle_fill(&render, dx, dy, W_ARROW, H_ARROW - ptn, 3);

	render.context->texture = &pat; /////////////////////////////////////

	/* ^[QbgEp[c\B */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &gi.field[row][col];
			switch(cell->type) {
			case CELL_TYPE_TARGET:
			case CELL_TYPE_PARTS:
				dx = DX_FIELD + 8 * col;
				dy = DY_FIELD + 8 * row;
				ptn = 0;
				if(col > 0) {
					cell2 = &gi.field[row][col - 1];
					switch(cell2->type) {
					case CELL_TYPE_TARGET:
					case CELL_TYPE_PARTS:
						if((cell->group == cell2->group) ||
						   (cell->color == cell2->color && cell->stat == CELL_STAT_ERASE && cell2->stat == CELL_STAT_ERASE)) {
							ptn |= 1 << 0;
						}
						break;
					}
				}
				if(row > 0) {
					cell2 = &gi.field[row - 1][col];
					switch(cell2->type) {
					case CELL_TYPE_TARGET:
					case CELL_TYPE_PARTS:
						if((cell->group == cell2->group) ||
						   (cell->color == cell2->color && cell->stat == CELL_STAT_ERASE && cell2->stat == CELL_STAT_ERASE)) {
							ptn |= 1 << 1;
						}
						break;
					}
				}
				if(col < FIELD_COLS - 1) {
					cell2 = &gi.field[row][col + 1];
					switch(cell2->type) {
					case CELL_TYPE_TARGET:
					case CELL_TYPE_PARTS:
						if((cell->group == cell2->group) ||
						   (cell->color == cell2->color && cell->stat == CELL_STAT_ERASE && cell2->stat == CELL_STAT_ERASE)) {
							ptn |= 1 << 2;
						}
						break;
					}
				}
				if(row < FIELD_ROWS - 1) {
					cell2 = &gi.field[row + 1][col];
					switch(cell2->type) {
					case CELL_TYPE_TARGET:
					case CELL_TYPE_PARTS:
						if((cell->group == cell2->group) ||
						   (cell->color == cell2->color && cell->stat == CELL_STAT_ERASE && cell2->stat == CELL_STAT_ERASE)) {
							ptn |= 1 << 3;
						}
						break;
					}
				}
				switch(cell->type) {
				case CELL_TYPE_TARGET:
					sx = SX_TARGET + ptn * 9;
					sy = SY_TARGET + cell->color * 9;
					if(cell->color == CELL_COLOR_CLEAR) sy += (gi.anm % 3) * 9;
					break;
				case CELL_TYPE_PARTS:
					sx = SX_PARTS + ptn * 9;
					sy = SY_PARTS + cell->color * 9;
					break;
				default:
					DIE();
				}
				render_object(&render, dx, dy, sx, sy, 9, 9, DRW_NOMAL);
				/*if(joy & PAD_B) render_printf_framed(&render, dx, dy+1, 2, 0x130, "%02d", cell->group);O[vԍeXgp*/
				break;
			}
		}
	}

	render.context->texture = &bg; //////////////////////////////////////

	/* fbhC^[QbgEp[cOʂɕ\B */
	dx = X_DEADLINE;
	dy = Y_DEADLINE;
	sx = X_DEADLINE;
	sy = Y_DEADLINE;
	render_object(&render, dx, dy, sx, sy, W_DEADLINE, H_DEADLINE, DRW_NOMAL);

	render.context->texture = &pat; /////////////////////////////////////

	/* vC[\B */
	dx = DX_FIELD + 8 * gi.player.col - 1;
	dy = DY_PLAYER;
	if(gi.player.stat == PLAYER_STAT_SHOT) dy++; /* VbgH */
	sx = SX_PLAYER;
	sy = SY_PLAYER;
	render_object(&render, dx, dy, sx, sy, W_PLAYER, H_PLAYER, DRW_NOMAL);

	/* VbgoȂAVbg\B */
	if(gi.shot.stat) {
		dx = DX_FIELD + 8 * gi.shot.col;
		dy = DY_FIELD + 8 * gi.shot.row;
		sx = SX_SHOT;
		sy = SY_SHOT; /* ݂̃VbgJ[ŕ\ƔČȂ̂ŁAŒɂ܂ */
		render_object(&render, dx, dy, sx, sy, 9, 9, DRW_NOMAL);

	/* VbgołȂ΁AƏ\Biwɂj */
	} else if(sight_disp) {
		col = gi.player.col;
		for(row = FIELD_ROWS - 1; row >= 0; row--) {
			cell = &gi.field[row][col];
			if(cell->type) break;
		}
		if(row < FIELD_ROWS - 1) {
			row++;
			dx = DX_FIELD + 8 * col;
			dy = DY_FIELD + 8 * row;
			sx = SX_SIGHT;
			sy = SY_SIGHT;
			render_object(&render, dx, dy, sx, sy, 9, 9, DRW_NOMAL);
			dx += 4;
			dy += 9;
			sx = dx;
			sy = DY_PLAYER - 1;
			if(dx < sy) render_dashes(&render, dx, dy, sx, sy, (gi.anm >> 1) & 3, dash_ptn, 4);
		}
	}

	/* \B */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &gi.field[row][col];
			switch(cell->type) {
			case CELL_TYPE_EXPLOSION:
				if(cell->cnt < EXPLOSION_CNT) {
					dx = DX_FIELD + 8 * col;
					dy = DY_FIELD + 8 * row;
					sx = SX_EXPLOSION;
					sy = SY_EXPLOSION;
					ptn = explosion_pos[cell->cnt] / 2/*̍LA*/;
					render_object(&render, dx - ptn, dy - ptn, sx, sy, 9, 9, DRW_NOMAL);
					render_object(&render, dx + ptn, dy - ptn, sx, sy, 9, 9, DRW_NOMAL);
					render_object(&render, dx - ptn, dy + ptn, sx, sy, 9, 9, DRW_NOMAL);
					render_object(&render, dx + ptn, dy + ptn, sx, sy, 9, 9, DRW_NOMAL);
				}
				break;
			}
		}
	}

	/* Aj[VJE^i߂܂B */
	gi.anm++;
}
